unit hiWaveHeader;

interface

uses Kol,Share,Debug;

type
  WAVHDR = packed record
    riff: array[0..3] of Char;
    len: integer;
    cWavFmt: array[0..7] of Char;
    dwHdrLen: integer;
    wFormat: Word;
    wNumChannels: Word;
    dwSampleRate: integer;
    dwBytesPerSec: integer;
    wBlockAlign: Word;
    wBitsPerSample: Word;
    cData: array[0..3] of Char;
    dwDataLen: integer;
  end;
  THIWaveHeader = class(TDebug)
   private
    FWavHeader:PStream;
    WaveHdr:WAVHDR;
   public
    _prop_Frequency:integer;
    _prop_Channels:Word;

    _data_Frequency:THI_Event;
    _data_Channels:THI_Event;
    _data_Size:THI_Event;
    _data_WavHeader:THI_Event;
    _event_onCreate:THI_Event;
    _event_onGet:THI_Event;

    procedure _work_doCreate(var _Data:TData; Index:word);
    procedure _work_doGet(var _Data:TData; Index:word);
    procedure _var_varWavHeader(var _Data:TData; Index:word);
    procedure _var_varFrequency(var _Data:TData; Index:word);
    procedure _var_varChannels(var _Data:TData; Index:word);
    procedure _var_varSize(var _Data:TData; Index:word);
  end;

implementation

procedure THIWaveHeader._work_doCreate;
begin
 FWavHeader := NewMemoryStream;
 WaveHdr.riff := 'RIFF';
 WaveHdr.len := ReadInteger(_Data,_data_Size,0) + SizeOf(WAVHDR) - 8;
 WaveHdr.cWavFmt := 'WAVEfmt ';
 WaveHdr.dwHdrLen := 16;
 WaveHdr.wFormat := 1;
 WaveHdr.wNumChannels := ReadInteger(_Data,_data_Channels,_prop_Channels);
 WaveHdr.dwSampleRate := ReadInteger(_Data,_data_Frequency,_prop_Frequency);
 WaveHdr.wBlockAlign := 4;
 WaveHdr.dwBytesPerSec := 16*ReadInteger(_Data,_data_Channels,_prop_Channels)*ReadInteger(_Data,_data_Frequency,_prop_Frequency) div 8;
 WaveHdr.wBitsPerSample := 16;
 WaveHdr.cData := 'data';
 WaveHdr.dwDataLen := ReadInteger(_Data,_data_Size,0);

 FWavHeader.Write(WaveHdr,SizeOf(WAVHDR));
 FWavHeader.Position := 0;
 _hi_OnEvent(_event_onCreate,FWavHeader);
end;

procedure THIWaveHeader._work_doGet;
begin
 FWavHeader := ReadStream(_Data,_data_WavHeader,nil);
 FWavHeader.Position := 0;
 FWavHeader.Read(WaveHdr,SizeOf(WAVHDR));
 if (FWavHeader=nil) or (WaveHdr.riff <> 'RIFF') then
  begin
   FWavHeader.Free;
   exit;
  end;
 _hi_OnEvent(_event_onGet);
 FWavHeader.Free;
end;

procedure THIWaveHeader._var_varWavHeader;
begin
 dtNull(_Data);
 if Assigned(FWavHeader) then dtStream(_Data,FWavHeader);
end;

procedure THIWaveHeader._var_varFrequency;
begin
 dtNull(_Data);
 dtInteger(_Data,WaveHdr.dwSampleRate);
end;

procedure THIWaveHeader._var_varChannels;
begin
 dtNull(_Data);
 dtInteger(_Data,WaveHdr.wNumChannels);
end;

procedure THIWaveHeader._var_varSize;
begin
 dtNull(_Data);
 dtInteger(_Data,WaveHdr.dwDataLen);
end;

end.